--Untouchable settings(please)	v
db = {}
parse('mp_hudscale 1')
db.Players = {}
Players = db.Players
db.red = "\169255100050"
db.green = "\169050255100"
db.gray = "\169177177177"
db.x = 425
db.y = 100
db.maxline = 15
--End of them					^

--debuffs and buffs list		v
db.list = {
	["Bleeding"] = {
		Description = "Every second player get damaged for 1-3pts.",
		Duration = 8,
		Icon = "gfx/mora/db/Bleeding.png",
		Debuff = true,
		Hooks = {
			["second"] = function(id,db_id)
				local dmg = math.random(1,3)
				if player(id,"health")-dmg<=0 then
					parse('customkill '..Players[id].db_table[db_id].Source..' \"Bleed out\" '..id)
				else
					parse("sethealth "..id.." "..player(id,"health")-dmg)
					parse("effect \"flare\" "..player(id,"x").." "..player(id,"y").." 1 1 255 000 000")
				end
			end
		}
	},
	["Regeneration"] = {
		Description = "Every second player is healed for 2pts.",
		Duration = 30,
		Icon = "gfx/mora/db/Regeneration.png",
		Hooks = {
			["second"] = function(id,db_id)
				parse("sethealth "..id.." "..player(id,"health")+2)
				parse("effect \"flare\" "..player(id,"x").." "..player(id,"y").." 1 1 255 255 255")
			end
		}
	},
	["Ammo save"] = {
		Description = "Reduces the chance of consuming any bullet ammunition by 20%.",
		Duration = 300,
		Icon = "gfx/mora/db/Ammosave.png",
		Hooks = {
			["attack"] = function(id,db_id)
				local weaponType = player(id, "weapontype")
				local legal = true
				local db_forbidden_ids = {47,48,49,88,50,69,74,78,85,51,52,53,54,72,73,75,76,86,89,77,87,55}
				for _,f_i in ipairs(db_forbidden_ids) do
					if weaponType == f_i then
						legal = false
						break
					end
				end
				if legal then
					local chance = 20
					local profit = math.random(1,100)
					if profit <= chance then
						local weaponType = player(id, "weapontype")
						local ammoIn,ammo = playerammo(id, weaponType)
						parse('setammo '..id..' '..weaponType..' '..(ammoIn+1)..' 1000')
						parse('sv_sound2 '..id..' "mora/db/chance.ogg"')
						msg2(id,db.green..'[Ammosave]'..db.gray..' - worked.')
					end
				end
			end
		}
	},
	["On fire"] = {
		Description = "Every second player get damaged for 2-5pts. Can be extinguished with water.",
		Duration = 8,
		Icon = "gfx/mora/db/Onfire.png",
		Debuff = true,
		Hooks = {
			["second"] = function(id,db_id)
				local dmg = math.random(2,5)
				if player(id,"health")-dmg<=0 then
					parse('customkill '..Players[id].db_table[db_id].Source..' \"Burned down\" '..id)
				else
					parse("sethealth "..id.." "..player(id,"health")-dmg)
				end
			end,
			["ms100"] = function(id,db_id)
				parse("effect \"fire\" " .. player(id,"x") .. " " .. player(id,"y") .. " 1 1")
			end,
			["movetile"] = function(id,db_id)
				if tile(player(id,'tilex'),player(id,'tiley'),"property") == 14 then
					msg2(id,db.red..'[On Fire]'..db.gray..' - is stopped.')
					parse('sv_soundpos "mora/db/firedown.ogg" '..player(id,"x")..' '..player(id,"y"))
					db.remove(id,db_id)
				end
			end,
		}
	},
	["Cursed inferno"] = {
		Description = "Every second player get damaged for 2-5pts. Can NOT be extinguished with water.",
		Duration = 8,
		Icon = "gfx/mora/db/CursedInferno.png",
		Debuff = true,
		Hooks = {
			["second"] = function(id,db_id)
				local dmg = math.random(2,5)
				if player(id,"health")-dmg<=0 then
					parse('customkill '..Players[id].db_table[db_id].Source..' \"Cursed fire\" '..id)
				else
					parse("sethealth "..id.." "..player(id,"health")-dmg)
				end
			end,
			["ms100"] = function(id,db_id)
				parse("effect \"flare\" "..player(id,"x").." "..player(id,"y").." 1 1 050 255 050")
			end
		}
	},
	["Withered weapon"] = {
		Description = "You can use no weapon except knife.",
		Duration = 4,
		Icon = "gfx/mora/db/WitheredWeapon.png",
		Debuff = true,
		Hooks = {
			["select"] = function(id,db_id)
				parse('setweapon '..id..' 50')
			end
		}
	},
	["Toxic injection"] = {
		Description = "Making a gas cloud on death.",
		Duration = "On dying",
		Icon = "gfx/mora/db/ToxicInjection.png",
		Hooks = {
			["die"] = function(id,db_id,x,y)
				parse('spawnprojectile '..id..' 72 '..x..' '..y..' 1 1')
			end
		}
	},
	["Life force"] = {
		Description = "Life is 20% increased.",
		Duration = 5,
		Icon = "gfx/mora/db/Lifeforce.png",
		Hooks = {},
		OnAdd = function(id)
			Players[id].Maxhealth = player(id,'maxhealth')
			local setcurrent_health = player(id,'health') * 1.2
			local setcurrent_maxhealth = player(id,'maxhealth') * 1.2
			
			parse('setmaxhealth '..id..' '..setcurrent_maxhealth)
			parse('sethealth '..id..' '..setcurrent_health)
		end,
		OnRemove = function(id)
			local health = math.ceil(player(id,'health') / 1.2)
			if player(id,'health')<= health then
				health = player(id,'health')
			end
			local maxhealth = Players[id].Maxhealth
			parse('setmaxhealth '..id..' '..maxhealth)
			parse('sethealth '..id..' '..health)
		end
	},
}
--End of the list				^

--db functions(meant to be untouchable)	v

--used to add a db
db.add = function(id, name, source)
	if not source then source = 0 end
	if not name or not id then return end
	local db_found = "none"
	local db_player_found = "none"
	local db_check = 0
	for k,v in pairs(Players[id].db_table) do
		db_check = db_check + 1
	end
	name = string.gsub(name,'_',' ')
	for k, v in pairs(db.list) do
		if string.lower(name) == string.lower(k) then
			db_found = k
			break
		end
	end
	for k, v in pairs(Players[id].db_table) do
		if string.lower(name) == string.lower(k) then
			db_player_found = k
			break
		end
	end
	if db_found ~= "none" then
		if db_player_found == "none" then
			
			Players[id].db_table[db_found] = {
				Duration = db.list[db_found].Duration,
				db_icon = image(db.list[db_found].Icon,-50,-50,2,id),
				Source = source,
			}
			imagealpha(Players[id].db_table[db_found].db_icon,0.5)
			if db.list[db_found].OnAdd then
				db.list[db_found].OnAdd(id)
			end
		else
			Players[id].db_table[db_found].Duration = db.list[db_found].Duration
			Players[id].db_table[db_found].Source = source
		end
		db.update(id)
	else
		print("ERROR: no such db name is found: "..name)
	end
end
--used to update gfx
function db.update(id)
	local db_icheck = 0
	local tabIndex = {}
	for k,v in pairs(Players[id].db_table) do
		db_icheck = db_icheck + 1
		tabIndex[db_icheck] = Players[id].db_table[k].db_icon
	end
	local db_xOffset = 135
	local db_yOffset = db.y - 85
	
	local ItemsLines = math.ceil(db_icheck/db.maxline)
	local slot_finder = 1
	
	for vs = 1, ItemsLines do
		local startup = ((1+(db.maxline*vs))-db.maxline)
		local enddown = (db.maxline*vs)
		for i = startup, enddown do
			if tabIndex[i]~=nil then
				imagepos(tabIndex[i],db_xOffset+(slot_finder*34),db_yOffset+(vs*34),0)
			end
			if slot_finder+1>db.maxline then
				slot_finder=1
			else
				slot_finder=slot_finder+1
			end
		end
	end
end
--used to add all the existing db
db.all = function(id)
	for k,v in pairs(db.list) do
		db.add(id,k)
	end
end
--used to remove certain db
db.remove = function(id,db_id)
	local db_index = "none"
	db_id = string.gsub(db_id,'_',' ')
	for k,v in pairs(Players[id].db_table) do
		if string.lower(db_id) == string.lower(k) then
			db_index = k
			break
		end
	end
	if db_index ~= "none" then
		freeimage(Players[id].db_table[db_index].db_icon)
		Players[id].db_table[db_index] = nil
		if db.list[db_id].OnRemove then
			db.list[db_id].OnRemove(id)
		end
		db.update(id)
		db.ms100()
	end
end
--End of db functions					^

--Some hooks required to be as they are, You might add the thing outside comments, stay prefer to do all things AFTER the ENGINE code:
db.ms100 = function()
	for _, id in pairs(player(0,"table")) do
		--ENGINE START
		local db_check = 0
		for k,v in pairs(Players[id].db_table) do
			db_check = db_check + 1
		end
		if db_check ~= 0 then
			local db_lines = math.ceil(db_check/db.maxline)
			Players[id].db_mouse.db_x = player(id,"mousex")
			Players[id].db_mouse.db_y = player(id,"mousey")
			
				local db_item = false
				local db_old = true
				
					for k, v in pairs(Players[id].db_table) do
						if Players[id].db_mouse.db_x>=object(v.db_icon,"x")-16 and Players[id].db_mouse.db_x<=object(v.db_icon,"x")+16 and Players[id].db_mouse.db_y>=object(v.db_icon,"y")-16 and Players[id].db_mouse.db_y<=object(v.db_icon,"y")+16 then
							db_item = true
							if Players[id].db_mouse.db_name ~= k then
								Players[id].db_mouse.db_name = k
								db_old = false
							end
						end
						if db.list[k].Hooks then
							for key, value in pairs(db.list[k].Hooks) do
								if key == "ms100" then
									db.list[k].Hooks[key](id,k)
								end
							end
						end
					end
				if db_item then
					tween_alpha(Players[id].db_nameshadow,1,1)
					tween_alpha(Players[id].db_nameline,1,1)
					tween_alpha(Players[id].db_descline,1,1)
					tween_alpha(Players[id].db_descshadow,1,1)
					imagescale(Players[id].db_nameshadow,string.len(Players[id].db_mouse.db_name)*3,1)
					imagescale(Players[id].db_nameline,string.len(Players[id].db_mouse.db_name)*3,1)
					imagescale(Players[id].db_descline,string.len(db.list[Players[id].db_mouse.db_name].Description)*1.2,1)
					imagescale(Players[id].db_descshadow,string.len(db.list[Players[id].db_mouse.db_name].Description)*1.2,1)
					imagepos(Players[id].db_nameline,db.x,db.y - 6 + db_lines * 33 -33,0)
					imagepos(Players[id].db_nameshadow,db.x,db.y + db_lines * 33 -33,0)
					imagepos(Players[id].db_descline,db.x,db.y +5 + db_lines * 33 -33,0)
					imagepos(Players[id].db_descshadow,db.x,db.y +10 + db_lines * 33 -33,0)
					if not db_old then
						for k, v in pairs(Players[id].db_table) do
							tween_alpha(v.db_icon,300,0.5)
						end
						local db_type = db.green.."Buff"
						if db.list[Players[id].db_mouse.db_name].Debuff then
							db_type = db.red.."Debuff"
						end
						local db_totaltext = db_type..": "..db.gray..Players[id].db_mouse.db_name
						tween_alpha(Players[id].db_table[Players[id].db_mouse.db_name].db_icon,300,1.0)
						parse('hudtxt2 '..id..' 99 "'..db_totaltext..'" '..db.x..' '..(db.y + (db_lines*33)-33)..' 1 1 9')
						parse('hudtxt2 '..id..' 100 "'..db.gray..db.list[Players[id].db_mouse.db_name].Description..'" '..db.x..' '..(db.y + (db_lines*33) + 10 -33)..' 1 1 9')
					end
					if type(db.list[Players[id].db_mouse.db_name].Duration)=="number" then
						parse('hudtxt2 '..id..' 101 "'..db.red..Players[id].db_table[Players[id].db_mouse.db_name].Duration..'/'..db.list[Players[id].db_mouse.db_name].Duration..'" '..object(Players[id].db_table[Players[id].db_mouse.db_name].db_icon,('x'))..' '..(object(Players[id].db_table[Players[id].db_mouse.db_name].db_icon,('y'))+20)..' 1 1 9')
					else
						parse('hudtxt2 '..id..' 101 "'..db.red..Players[id].db_table[Players[id].db_mouse.db_name].Duration..'" '..object(Players[id].db_table[Players[id].db_mouse.db_name].db_icon,('x'))..' '..(object(Players[id].db_table[Players[id].db_mouse.db_name].db_icon,('y'))+20)..' 1 1 9')
					end
				else
					for k, v in pairs(Players[id].db_table) do
						tween_alpha(v.db_icon,300,0.5)
					end
					
					tween_alpha(Players[id].db_nameshadow,300,0.0)
					tween_alpha(Players[id].db_nameline,300,0.0)
					tween_alpha(Players[id].db_descline,300,0.0)
					tween_alpha(Players[id].db_descshadow,300,0.0)
					
					parse("hudtxtalphafade "..id.." 99 300 0.0")
					parse("hudtxtalphafade "..id.." 100 300 0.0")
					parse("hudtxtalphafade "..id.." 101 300 0.0")
					Players[id].db_mouse.db_name = "none"
				end
		else
			Players[id].db_mouse.db_x = 0
			Players[id].db_mouse.db_y = 0
			Players[id].db_mouse.db_name = "none"
			for k, v in pairs(Players[id].db_table) do
				tween_alpha(v.db_icon,300,0.5)
			end
			
			tween_alpha(Players[id].db_nameshadow,300,0.0)
			tween_alpha(Players[id].db_nameline,300,0.0)
			tween_alpha(Players[id].db_descline,300,0.0)
			tween_alpha(Players[id].db_descshadow,300,0.0)
			
			parse("hudtxtalphafade "..id.." 99 300 0.0")
			parse("hudtxtalphafade "..id.." 100 300 0.0")
			parse("hudtxtalphafade "..id.." 101 300 0.0")
		end
		--ENGINE END, YOUR PLAYER CODE IS NEXT:
			
		--END OF YOUR PLAYER CODE.
	end
	--YOUR ms100 hook CODE:
		
	--END OF YOUR ms100 hook CODE.
end
addhook("ms100","db.ms100")

db.die = function(victim, killer, weapon, x, y, killerobject)
	--ENGINE START
	for k, v in pairs(Players[victim].db_table) do
		for key, value in pairs(db.list[k].Hooks) do
			if key == "die" then
				db.list[k].Hooks[key](victim,k,x,y)
			end
		end
		freeimage(v.db_icon)
		v.db_icon = nil
	end	
	Players[victim].db_table = {}
	db.ms100()
	--ENGINE END, YOUR CODE IS NEXT:
	
	--END OF YOUR CODE.
end
addhook("die","db.die")

db.second = function()
	for _, id in pairs(player(0,"table")) do
		--ENGINE START:
		local db_check = 0
		for k,v in pairs(Players[id].db_table) do
			db_check = db_check + 1
		end
		if db_check ~= 0 then
			for k, v in pairs(Players[id].db_table) do
				for key, value in pairs(db.list[k].Hooks) do
					if key == "second" then
						db.list[k].Hooks[key](id,k)
					end
				end
				if type(v.Duration)=="number" then
					if v.Duration - 1 > 0 then
						v.Duration = v.Duration - 1
					else
						db.remove(id,k)
					end
				end
			end
		end
		--ENGINE END. YOUR PLAYER CODE IS NEXT:
		
		--END OF YOUR PLAYER CODE.
	end
	--YOUR second hook CODE:
	
	--END OF YOUR second hook CODE.
end
addhook("second","db.second")


db.connect = function(id)
	--ENGINE START:
	if not (type(Players[id])=="table") then
		Players[id] = {
			db_mouse = {
				db_x = 0,
				db_y = 0,
				db_name = "none"
			},
			db_nameline = image("gfx/mora/db/db_headline.png",425,db.y-5,2,id),
			db_nameshadow = image("gfx/mora/db/db_shadow.png",425,db.y,2,id),
			db_descline = image("gfx/mora/db/db_headline.png",425,db.y+5,2,id),
			db_descshadow = image("gfx/mora/db/db_shadow.png",425,db.y+10,2,id),
			db_table = {},
		}
		imagealpha(Players[id].db_nameline,0.0)
		imagealpha(Players[id].db_nameshadow,0.0)
		imagealpha(Players[id].db_descline,0.0)
		imagealpha(Players[id].db_descshadow,0.0)
	end
	--ENGINE END. YOUR CODE IS NEXT:
	
	--END OF YOUR CODE.
end
addhook("connect","db.connect")

db.leave = function(id,reason)
	--ENGINE START:
	if type(Players[id]) == "table" then
		for k, v in pairs(Players[id].db_table) do
			freeimage(v.db_icon)
			v.db_icon = nil
		end	
		Players[id].db_table = {}
		freeimage(Players[id].db_nameline)
		freeimage(Players[id].db_nameshadow)
		freeimage(Players[id].db_descline)
		freeimage(Players[id].db_descshadow)
		Players[id] = nil
	end
	for _, pid in pairs(player(0,"table")) do
		if pid ~= id then
			if type(Players[pid]) == "table" then
				for key,value in pairs(Players[pid].db_table) do
					if value.Source == id then
						value.Source = 0
					end
				end
			end
		end
	end
	--ENGINE END. YOUR CODE IS NEXT:
	
	--END OF YOUR CODE.
end
addhook("leave","db.leave")
--End of the some hooks required to be as they are, You might add the hting outside comments, stay prefer to do all things before the engine code

--CUSTOM HOOKS START: These hooks You see next is used by db.list. They're not a part of the ENGINE but required to work with already exists db.

db.select = function(id,type,mode)
	local db_check = 0
	for k,v in pairs(Players[id].db_table) do
		db_check = db_check + 1
	end
	if db_check ~= 0 then
		for k, v in pairs(Players[id].db_table) do
			for key, value in pairs(db.list[k].Hooks) do
				if key == "select" then
					db.list[k].Hooks[key](id,k)
				end
			end
		end
	end
end
addhook("select","db.select")

db.movetile = function(id,x,y)
	local db_check = 0
	for k,v in pairs(Players[id].db_table) do
		db_check = db_check + 1
	end
	if db_check ~= 0 then
		for k, v in pairs(Players[id].db_table) do
			for key, value in pairs(db.list[k].Hooks) do
				if key == "movetile" then
					db.list[k].Hooks[key](id,k)
				end
			end
		end
	end
end
addhook("movetile","db.movetile")

db.attack = function(id)
	for k,v in pairs(Players[id].db_table) do
		for key, value in pairs(db.list[k].Hooks) do
			if key == "attack" then
				db.list[k].Hooks[key](id)
			end
		end
	end
end
addhook("attack","db.attack")

--CUSTOM HOOKS END.

